;==============================================================================
;       Test Department's WINDOWS 32 BIT x86 ASSEMBLY example's        xxx
;==============================================================================

;==============================================================================
; ==> td_win32asm_nanocd :
;------------------------------------------------------------------------------
; Just another Audio CD Player.
; Nothing special, please take a look into my multimedia example's.
; The interesting thing may be that I use regions for the main window and for
; the digits in the Track Display.
; The digits are normal bitmaps.
; I create the hidden windows and regions on WM_CREATE, later on Runtime
; (WM_TIMER) a assign the correct digit (STM_SETIMAGE) and region to the window.
;
; This program works well on WinXP ...
; 
; Test Department
;
; 2017 Remix by el Comandante, fixed graphic error while inserting new cd and more


;==============================================================================
; Assembler directives
;------------------------------------------------------------------------------
.386                    ; specifies the processor our program want run on
.Model Flat ,StdCall    ; always the same for Win9x (32 Bit)
option casemap:none     ; case sensitive !!!

;==============================================================================
; Include all files where API functins resist you want use, set correct path
;------------------------------------------------------------------------------
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\winmm.lib

;==============================================================================
; Declaration of used API functions,take a look into WIN32.HLP and *.inc files
;------------------------------------------------------------------------------
GetModuleHandleA        PROTO :DWORD
LoadIconA               PROTO :DWORD,:DWORD
LoadCursorA             PROTO :DWORD,:DWORD
RegisterClassExA        PROTO :DWORD
CreateWindowExA         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,
                              :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
ShowWindow              PROTO :DWORD,:DWORD
UpdateWindow            PROTO :DWORD
GetMessageA             PROTO :DWORD,:DWORD,:DWORD,:DWORD
TranslateMessage        PROTO :DWORD
DispatchMessageA        PROTO :DWORD
PostQuitMessage         PROTO :DWORD
DefWindowProcA          PROTO :DWORD,:DWORD,:DWORD,:DWORD
ExitProcess             PROTO :DWORD
DestroyWindow           PROTO :DWORD
SendMessageA            PROTO :DWORD,:DWORD,:DWORD,:DWORD
InvalidateRect          PROTO :DWORD,:DWORD,:DWORD
SetFocus                PROTO :DWORD
LoadBitmapA             PROTO :DWORD,:DWORD
CreatePatternBrush      PROTO :DWORD
SelectObject            PROTO :DWORD,:DWORD
DeleteObject            PROTO :DWORD
ReleaseCapture          PROTO
GetWindowRect           PROTO :DWORD,:DWORD

GetDC        		PROTO :DWORD
CreateCompatibleDC      PROTO :DWORD
ReleaseDC               PROTO :DWORD,:DWORD
DeleteDC                PROTO :DWORD

GetPixel                PROTO :DWORD,:DWORD,:DWORD
CreateRectRgn           PROTO :DWORD,:DWORD,:DWORD,:DWORD
CombineRgn              PROTO :DWORD,:DWORD,:DWORD,:DWORD
SetWindowRgn            PROTO :DWORD,:DWORD,:DWORD
GetWindowRgn            PROTO :DWORD,:DWORD
ClientToScreen          PROTO :DWORD,:DWORD
PtInRect                PROTO :DWORD,:DWORD,:DWORD

Shell_NotifyIconA       PROTO :DWORD,:DWORD
GetCursorPos            PROTO :DWORD
SetForegroundWindow     PROTO :DWORD
TrackPopupMenuEx        PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

GetSystemDirectoryA     PROTO :DWORD,:DWORD
ShellExecuteA           PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD

LoadStringA             PROTO :DWORD,:DWORD,:DWORD,:DWORD
lstrcpyA                PROTO :DWORD,:DWORD

timeGetDevCaps          PROTO :DWORD,:DWORD
timeSetEvent            PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
timeKillEvent           PROTO :DWORD

mciSendCommandA         PROTO :DWORD,:DWORD,:DWORD,:DWORD
PlaySoundA              PROTO :DWORD,:DWORD,:DWORD

Sleep                   PROTO :DWORD

;==============================================================================
; .const = the constants area starts here,constants are defined and fixed
;------------------------------------------------------------------------------
.const 
; - Parameter MAIN WINDOW CallBack Procedure ( API=RegisterClassExA ) -
WP1_CallBack            equ [ebp+4]     ;return address
WP1_hWnd                equ [ebp+8]     ;handle of window who receives message
WP1_uMsg                equ [ebp+12]    ;the message number
WP1_wParam              equ [ebp+16]    ;extra info about the message
WP1_lParam              equ [ebp+20]    ;extra info about the message

;==============================================================================
; .Data = the data area starts here, datas are defined but not fixed
;------------------------------------------------------------------------------
.Data
ClassName               db "nanoCD2017b",0      ;windows class
WindowName              db "nanoCD2017b",0      ;window name
TrayName                db "nanoCD2017b",0      ;tray name
OpenFile                db "open",0                         ;used by ShellExecute
Control                 db "control.exe ",0                 ;control loader
mmsys                   db "mmsys.cpl",0                    ;control to load
TD_URL                  db "http://www.masm32.com",0        ;URL MASM32
ButtonClassName         db "BUTTON",0                       ;predefined Class !
StaticClassName         db "STATIC",0                       ;predefined Class !
ToolTipsClassName       db "Tooltips_class32",0             ;predefined class !

align 4
flag_MCI        dd 0h           ;general mci flag
flag_MCI_open   dd 0h           ;opening device done flag
flag_MCI_eject  dd 0h           ;eject flag
flag_MCI_play   dd 0h           ;play flag
flag_MCI_pause  dd 0h           ;pause flag
flag_MCI_cmd    dd 0FFh         ;command flag
Xpos_org        dd 0            ;X orgin point window
Ypos_org        dd 0            ;Y orgin point window
Xpos_max        dd 254          ;max. window width
Ypos_max        dd 184          ;max. window height
Xpos_Dmax       dd 16           ;
Ypos_Dmax       dd 21           ;

align 4
; - Array of BUTTON window parameter -
BUTTON_id       dd 100h,101h,102h,103h,104h,105h,106h,107h,108h,109h    ;array button ID's
BUTTON_height   dd 0022,0022,0022,0022,0022,0020,0020,0020,0020,0020    ;array button height
BUTTON_width    dd 0028,0028,0028,0028,0028,0028,0028,0028,0028,0028    ;array button width
BUTTON_ypos     dd 0092,0092,0092,0092,0092,0120,0120,0120,0120,0120    ;array button ypos
BUTTON_xpos     dd 0053,0083,0113,0143,0173,0053,0083,0113,0143,0173    ;array button xpos
BUTTON_hWnd     dd 0000,0000,0000,0000,0000,0000,0000,0000,0000,0000    ;array button handle
BUTTON_BMP      dd 1100,1110,1120,1130,1140,1150,1160,1170,1180,1190    ;array bitmap ID's
BUTTON_hBMP     dd 0000,0000,0000,0000,0000,0000,0000,0000,0000,0000    ;array bitmap handle
BUTTON_ttip     dd 6100,6110,6120,6130,6140,6150,6160,6170,6180,6190    ;array tooltip ID's

; - Array of SubRoutine address for the choosen Function, generated at RunTime -
BUTTON_Table    dd 0000,0000,0000,0000,0000,0000,0000,0000,0000,0000    ;BUTTON call table

; - Array of STATIC window parameter -
STATIC_id       dd 200h,201h,202h,203h,204h,205h,206h   ;array static ID's
STATIC_height   dd 0021,0021,0021,0021,0021,0021,0021   ;array static height
STATIC_width    dd 0016,0016,0016,0016,0016,0016,0016   ;array static width
STATIC_ypos     dd 0054,0054,0054,0054,0054,0054,0054   ;array static ypos
STATIC_xpos     dd 0062,0078,0114,0130,0160,0176,0144   ;array static xpos
STATIC_hWnd     dd 0000,0000,0000,0000,0000,0000,0000   ;array static handle

; - Array of STATIC window parameter (old Digits index value) -
STATIC_old      dd 0000,0000,0000,0000,0000,0000,0000   ;array
STATIC_and      dd 000000FFh,0000FF00h,00FF0000h
STATIC_shr      db 00h,08h,10h

align 4
; - Array of STATmp window parameter -
STATmp_id       dd 300h,301h,302h,303h,304h,305h,306h,307h,308h,309h,310h,311h  ;array static ID's
STATmp_hWnd     dd 0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000  ;array static handle
STATmp_BMP      dd 1200,1210,1220,1230,1240,1250,1260,1270,1280,1290,1300,1310  ;array bitmap ID's
STATmp_hBMP     dd 0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000  ;array bitmap handle

align 4
; - Array of extra images -
EXTRA_BMP       dd 1121,1131    ;array bitmap ID's
EXTRA_hBMP      dd 0000,0000    ;array bitmap handle

align 4
; - WndClassEx Structure -
cbSize          dd 0h           ;size in bytes of this structure
style           dd 0h           ;window style
lpfnWndProc     dd 0h           ;address of user proc function
cbclsExtra      dd 0h           ;extra bytes to allocate set to 0
cbWndExtra      dd 0h           ;extra bytes class directive, rc file
hInstance       dd 0h           ;program handle(API=GetModuleHandleA)
hIcon           dd 0h           ;handle of icon (API=LoadIconA)
hcursor         dd 0h           ;handle of cursor (API=LoadCursor)
hbrBackground   dd 0h           ;background color, 0=transparent
lpszMenuName    dd 0h           ;name of menu class in resource file
lpszClassName   dd 0h           ;name of windows this window class
hIconSm         dd 0h           ;iconhandle 0=search in resource file

align 4
; - Msg Structure -
hWnd            dd 0h           ;handle of window who receives message
message         dd 0h           ;the message number
wParam          dd 0h           ;extra info about the message
lParam          dd 0h           ;extra info about the message 
time            dd 0h           ;time the message was posted 
xpt             dd 0h           ;cursor x-position, POINT struc
ypt             dd 0h           ;cursor x-position, POINT struc

align 4
; - RECT structure (left pad in graphic) -
left_rc_left    dd 08           ;x-coord. upper-left corner rectangle
left_rc_top     dd 91           ;y-coord. upper-left corner rectangle
left_rc_right   dd 44           ;x-coord. lower-right corner rectangle
left_rc_bottom  dd 150          ;y-coord. lower-right corner rectangle

align 4
; - RECT structure (right pad in graphic) -
right_rc_left   dd 209          ;x-coord. upper-left corner rectangle
right_rc_top    dd 91           ;y-coord. upper-left corner rectangle
right_rc_right  dd 245          ;x-coord. lower-right corner rectangle
right_rc_bottom dd 150          ;y-coord. lower-right corner rectangle

;==============================================================================
; .Data? = the data? area starts here, not defined and not fixed
;------------------------------------------------------------------------------
.data?

align 4
temp            dd ?            ;temp var
counter         dd ?            ;
tempT           dd ?            ;temp var
counterT        dd ?

hDC             dd ?            ;handle device context
hDC_main        dd ?            ;compatible device context memory
hDC_temp        dd ?            ;handle DC, temporary
hBMP_main       dd ?            ;handle bitmap background
hBR_main        dd ?            ;handle brush background
hObj_old        dd ?            ;handle old object
hRgn            dd ?            ;handle region
hWnd_tooltip    dd ?            ;handle tooltip
hWnd_temp       dd ?            ;handle temporary Static window
timerevent      dd ?            ;handle timer

Buffer          db 104h dup (?) ;buffer

align 4
; - POINT stucture (normal structure for the window procedure !) -
pointx          dd ?            ;x coordinate
pointy          dd ?            ;y coordinate

align 4
; - toolinfo structure -
ti_cbSize       dd ?            ;size, in bytes, of TOOLINFO structure
ti_uFlags       dd ?            ;set of bit flags, look into win32.hlp
ti_hwnd         dd ?            ;handle window that contains the tool
ti_uId          dd ?            ;application-defined tool identifier
ti_RECT_left    dd ?            ;x-coord. upper-left corner rectangle
ti_RECT_top     dd ?            ;y-coord. upper-left corner rectangle
ti_RECT_right   dd ?            ;x-coord. lower-right corner rectangle
ti_RECT_bottom  dd ?            ;y-coord. lower-right corner rectangle
ti_hinst        dd ?            ;instance contains tool string resource
ti_lpszText     dd ?            ;buffer contains tool text or identifier

align 4
; - NOTIFYICONDATA Structure -
nid_cbSize              dd ?            ;size of (NOTIFYICONDATA)
nid_hWnd                dd ?            ;handle for icon notification messages
nid_uID                 dd ?            ;Application-defined ID taskbar icon
nid_uFlags              dd ?            ;flags which structure data are valid
nid_uCallbackMessage    dd ?            ;identifier for notification messages
nid_hIcon               dd ?            ;handle icon to add, modify or delete
nid_szTip               db 64 dup(?)    ;tooltip text displays for taskbar icon

align 4
; - MCI_OPEN_PARMS Structure -
open_dwCallback         dd ?
open_wDeviceID          dd ?
open_lpstrDeviceType    dd ?
open_lpstrElementName   dd ?
open_lpstrAlias         dd ?

align 4
; - MCI_SET_PARMS Structure -
set_dwCallback          dd ?
set_dwTimeFormat        dd ?
set_dwAudio             dd ?

align 4
; - MCI_PLAY_PARMS Structure -
play_dwCallback         dd ?
play_dwFrom             dd ?
play_dwTo               dd ?

align 4
; - MCI_GENERIC_PARMS Structure -
generic_dwCallback      dd ?

align 4
; - MCI_STATUS_PARMS Structure -
status_dwCallback       dd ?
status_dwReturn         dd ?
status_dwItem           dd ?
status_dwTrack          dd ?

align 4
; - MCI_SEEK Structure -
seek_dwCallback         dd ?
seek_dwTo               dd ?

align 4
; - TIMECAPS Structure ( API=timeGetDevCaps ) -
wPeriodMin              dd ?            ;TIMER minimum supported resolution
wPeriodMax              dd ?            ;TIMER maximum supported resolution

;==============================================================================
; .CODE = our code area starts here     Main=label of our program code
;------------------------------------------------------------------------------
.Code
Main:

;==============================================================================
; Always get your program ID first (API=GetModuleHandleA)
;------------------------------------------------------------------------------
push    0h                      ;lpModuleHandle, 0=get program handle
call    GetModuleHandleA        ;- API Function -
mov     hInstance,eax           ;return value in eax=handle of program

;==============================================================================
; The API function "RegisterClassExA" registers a window class
; This API needs a "WNDCLASSEX" structure so we fill it with correct values
;------------------------------------------------------------------------------
mov     cbSize,30h                      ;size in bytes of WNDCLASSEX structure
mov     style,3h                        ;window style, CS_HREDRAW, CS_VREDRAW
mov     lpfnWndProc,OFFSET WP1          ;address of user lpfnWndProc function
mov     cbclsExtra,0h                   ;extra bytes to allocate set to 0
mov     cbWndExtra,0h                   ;class directive in rc file
push    1001
push    hInstance
call    LoadBitmapA                     ;load background bitmap
mov     hBMP_main,eax
push    eax
call    CreatePatternBrush              ;create brush
mov     hBR_main,eax
mov     hbrBackground,eax               ;assign brush
mov     lpszMenuName,0                  ;menu name in resource file
mov     lpszClassName,OFFSET ClassName  ;name of windows class
;------------------------------------------------------------------------------
; API "LoadIconA" loads an icon defined in the resource file and store the
; handle in the "WNDCLASSEX" structure
;------------------------------------------------------------------------------
push    1000                    ;icon-string or icon resource id
push    hInstance               ;our program handle
call    LoadIconA               ;- API Function -
mov     hIcon,eax               ;handle of newly loaded icon
mov     hIconSm,eax             ;iconhandle 0=search in rc file
;------------------------------------------------------------------------------
; API "LoadCursorA" loads a default system cursor, in this case we must set
; hInstance to 0 and lpCursorName to a default system cursor value, here 32512
; Then we store the cursor handle in the "WNDCLASSEX" structure
;------------------------------------------------------------------------------
push    32512                       ;lpCursorName, default value in dezimal
push    0h                          ;hInstance, 0=default system cursor
call    LoadCursorA                 ;- API Function -
mov     hcursor,eax                 ;store handle of the cursor
;------------------------------------------------------------------------------
; Now, after filled the "WNDCLASSEX" structure we call API "RegisterClassEx"
;------------------------------------------------------------------------------
push    OFFSET cbSize           ;pointer to WNDCLASSEX structure
call    RegisterClassExA        ;- API Function -

;==============================================================================
; API "CreateWindowExA" creates an overlapped, pop-up, or child window with an
; extended style. The return value in EAX is the handle of the new window.
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
push    0h                      ;hMenu, handle window menu 0=class menu
push    0h                      ;hWndParent, handle parent window 0=no
push    Ypos_max                ;intnHeight, window height pixel
push    Xpos_max                ;intnWidth, window width pixel
push    00000040h               ;inty, vertical position window
push    000000D0h               ;intx, horizontal position window
push    80080000h               ;dwStyle, WS_POPUP, WS_CLIPCHILDREN
push    OFFSET WindowName       ;lpWindowName, pointer to window name
push    OFFSET ClassName        ;lpClassName, pointer to class name
push    0h                      ;dwExStyle,
call    CreateWindowExA         ;- API Function -
mov     hWnd,eax                ;hwnd,return value=handle of window

;==============================================================================
; API "PlaySoundA" plays a wave sound, the value 40005h means the sound is
; inside the resource file.
;------------------------------------------------------------------------------
push    40005h                          ;SND_RESOURCE+SND_ASYNC
push    hInstance                       ;handle of our program
push    1003                            ;wave name in rc file
call    PlaySoundA                      ;- API Function -

;==============================================================================
; API "ShowWindow" function sets the specified window's show state. 
;------------------------------------------------------------------------------
push    1h                      ;nCmdShow, show state 1=SW_SHOWNORMAL
push    hWnd                    ;hwnd, handle of window
call    ShowWindow              ;- API Function -

;==============================================================================
; API "UpdateWindow" updates the area of the specified window by sending a
; WM_PAINT message to the window if the window's update region is not empty.
;------------------------------------------------------------------------------
push    hWnd                    ;hwnd, handle of window
call    UpdateWindow            ;- API Function -

;==============================================================================
; API "GetMessageA" retrieves a message & places it in the specified structure.
;------------------------------------------------------------------------------
LoopGetMessage:
push    0h                      ;wMsgFilterMax, highest message value
push    0h                      ;wMsgFilterMin, lowest message value
push    0h                      ;hWnd, handle of window who gets msg.
push    OFFSET hWnd             ;lpMsg, pointer to MSG structure
call    GetMessageA             ;- API Function -
cmp     eax,0h                  ;check if return value=0 (exit)
je      ExitPrg                 ;if return value is 0 goto LABEL

;==============================================================================
; API "TranslateMessage" translates key code into ASCII character messages
;------------------------------------------------------------------------------
push    OFFSET hWnd             ;lpMSG, pointer to msg structure
call    TranslateMessage        ;- API Function - keyboard code

;==============================================================================
; API "DispatchMessageA" function dispatches a message to a window procedure.
;------------------------------------------------------------------------------
push    OFFSET hWnd             ;lpMSG, pointer to msg structure
call    DispatchMessageA        ;- API Function -
jmp     LoopGetMessage          ;check for message again, goto LABEL

ExitPrg:
;==============================================================================
; Next we terminate our program (API=ExitProcess)
;------------------------------------------------------------------------------
push    hInstance               ;push our programm handle to exit
call    ExitProcess             ;- API Function -

;##############################################################################
; The Window Procedure lpfnWndProc (API=RegisterClassExA) for this window.
;------------------------------------------------------------------------------
WP1:
push    ebp                     ;create stack frame
mov     ebp,esp                 ;
pushad                          ;push all register to the stack

mov     eax,WP1_uMsg            ;move the message number to eax
;==============================================================================
; WM_CREATE (value=01h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_01h:
cmp     eax,1h                  ;check if WM_CREATE message recieved
jne     WP1_uMsg_02h            ;if not goto label
call    My_Rgn_main             ;- SubRoutine -
call    My_Create_Tooltip       ;- SubRoutine -
call    My_Create_Button        ;- SubRoutine -
call    My_Init_BUTTON_Table    ;- SubRoutine -
call    My_ExtraBitmap          ;- SubRoutine -
call    My_Create_Statmp        ;- SubRoutine -
call    My_Create_Static        ;- SubRoutine -
;------------------------------------------------------------------------------
; timeGetDevCaps function queries the timer device to determine its resolution.
; Returned values in the TIMECAPS struc are different from system to system.
;------------------------------------------------------------------------------
push    8h                          ;cbtc, size in bytes TIMECAPS structure
push    OFFSET wPeriodMin           ;ptc, address of a TIMECAPS structure
call    timeGetDevCaps              ;- API Function -
;------------------------------------------------------------------------------
; The timeSetEvent function starts a PRECISION timer event. After activated, it
; calls the specified callback function. It runs in its own thread ! 
;------------------------------------------------------------------------------
push    1h                      ;fuEvent, timer type, TIME_PERIODIC=1h
push    0h                      ;dwUser, user-supplied callback data 
push    OFFSET TP               ;lpTimeProc, address callback function
push    wPeriodMin              ;uResolution, resolution in ms
push    500                     ;uDelay, event delay in milliseconds
call    timeSetEvent            ;- API Function -
mov     timerevent,eax          ;store handle
jmp     WP1_return

;==============================================================================
; WM_DESTROY (value=02h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_02h:
cmp     eax,2h                  ;check if value=2h (WM_DESTROY)
jne     WP1_uMsg_05h            ;if not 2h go to LABEL
xyz:                            ;label for internal testing purpose
call    My_CleanSystem          ;- SubRoutine -
;------------------------------------------------------------------------------
; API "PostQuitMessage" indicates to Windows a request to terminate
;------------------------------------------------------------------------------
push    0h                      ;nExitCode, exit code=wParam
call    PostQuitMessage         ;- API Function -
popad                           ;pop all register back from stack
xor     eax,eax                 ;set eax to 0 to exit our program
mov     esp,ebp                 ;delete stack frame
pop     ebp                     ;
ret     10h                     ;return and clear stack

;==============================================================================
; WM_SIZE (value=05h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_05h:
cmp     eax,5h                  ;check if value=5h (WM_SIZE)
jne     WP1_uMsg_0Fh            ;if not 5h go to LABEL
mov     eax,WP1_wParam          ;extra info about message
cmp     ax,01h                  ;SIZE_MINIMIZED=1h
jne     WP1_return              ;if not 1h goto LABEL
mov     nid_cbSize,58h          ;size of NOTIFYCONDATA structure
mov     eax,WP1_hWnd            ;
mov     nid_hWnd,eax            ;handle of window
mov     nid_uID,0h              ;icon ID, a free value of your choice
mov     nid_uFlags,7h           ;NIF_ICON=2h,NIF_MESSAGE=1h,NIF_TIP=4h
mov     nid_uCallbackMessage,500h;message send to window on mouse events
mov     eax,hIcon               ;we use the same icon handle loaded
mov     nid_hIcon,eax           ;for the main window
;------------------------------------------------------------------------------
; API "lstrcpyA" copy's a string from source to destination. 
;------------------------------------------------------------------------------
push    OFFSET TrayName         ;source address of icon tip string
push    OFFSET nid_szTip        ;destination address in structure
call    lstrcpyA                ;- API Function -
;------------------------------------------------------------------------------
; API "ShowWindow" function sets the specified window's show state. 
;------------------------------------------------------------------------------
push    0h                      ;nCmdShow, show state 0h=SW_HIDE
push    WP1_hWnd                ;hWnd, handle of window
call    ShowWindow              ;- API Function -
;------------------------------------------------------------------------------
; API "Shell_NotifyIconA" here sends a msg. to the system to add a taskbar icon 
;------------------------------------------------------------------------------
push    OFFSET nid_cbSize       ;pnid, address of NOTIFYCONDATA struc.
push    0h                      ;dwMessage, NIM_ADD=0h
call    Shell_NotifyIconA       ;- API Function -
jmp     WP1_return 

;==============================================================================
; WM_PAINT (value=0Fh) message, used to repaint the window area
;------------------------------------------------------------------------------
WP1_uMsg_0Fh:
cmp     eax,0Fh                 ;check if WM_PAINT message recieved
jne     WP1_uMsg_7Eh            ;if not goto label
jmp     WP1_return

;==============================================================================
; WM_DISPLAYCHANGE (value=7Eh) message, used to repaint the window area
;------------------------------------------------------------------------------
WP1_uMsg_7Eh:
cmp     eax,7Eh                 ;check if WM_DISPLAYCHANGE message recieved
jne     WP1_uMsg_111h           ;if not goto label
;------------------------------------------------------------------------------
; API "InvalidateRect" adds a rectangle to specified window's update region.
; This function performs a WM_PAINT message.
;------------------------------------------------------------------------------
push    0h                      ;bErase, erase-background flag
push    0h                      ;lpRect, rect structure, 0h=client area
push    WP1_hWnd                ;hWnd, handle window update region
call    InvalidateRect          ;- API Function -
jmp     WP1_return

;==============================================================================
; WM_COMMAND (value=111h) message recieved ?
;------------------------------------------------------------------------------
WP1_uMsg_111h:
cmp     eax,111h                ;check if WM_COMMAND message recieved
jne     WP1_uMsg_201h           ;if not goto label
mov     eax,WP1_wParam          ;
and     eax,0FFFFh              ;get item, control, or accelerator identifier
My_BUTTON:
mov     temp,0h                 ;store it in var, so win do not destroy it ...
mov     counter,0h              ;counter for number of windows created
My_BUTTON_ID_Next:
mov     ebx,OFFSET BUTTON_id    ;get OFFSET to BUTTON id array
add     ebx,temp
cmp     [ebx],eax               ;match button ID ?
jne     My_BUTTON_ID_Inc        ;if not test next
mov     ebx,OFFSET BUTTON_Table ;get OFFSET to BUTTON call array
add     ebx,temp
mov     eax,[ebx]
call    eax                     ;call BUTTON function
;------------------------------------------------------------------------------
; API "SetFocus" sets the keyboard focus to the specified window
;------------------------------------------------------------------------------
push    WP1_hWnd                ;hwnd, handle of window to receive focus
call    SetFocus                ;- API Function -
jmp     WP1_return
My_BUTTON_ID_Inc:
add     temp,4                  ;add 4 because a doubleword contains 4 byte
inc     counter                 ;inc counter
cmp     counter,0Ah             ;max. number of BUTTON windows
jb      My_BUTTON_ID_Next       ;loop if below
jmp     WP1_return

;==============================================================================
; WM_LBUTTONDOWN (value=201h) message recieved ?
;------------------------------------------------------------------------------
WP1_uMsg_201h:
cmp     eax,201h                ;check if WM_LBUTTONDOWN message recieved
jne     WP1_uMsg_500h           ;if not goto label
mov     eax,WP1_lParam          ;lParam, contains X/Y mouse coordinates
and     eax,0FFFFh              ;x position in low word
mov     pointx,eax              ;store xpos in point structure
mov     eax,WP1_lParam          ;
shr     eax,10h                 ;y position in high word
mov     pointy,eax              ;store ypos in point structure
cmp     eax,23                  ;top part of window activates moving
jb      MoveWin                 ;if above notting to move
;------------------------------------------------------------------------------
; API "PtInRect" determines if a specified point lies within specified rectangle
;------------------------------------------------------------------------------
push    pointy                  ;ypt, POINT structure
push    pointx                  ;xpt, Point structure
push    OFFSET left_rc_left     ;lprc, address structure with rectangle
call    PtInRect                ;- API Function -
cmp     eax,1h                  ;return value 1h=match
je      MoveWin                 ;
;------------------------------------------------------------------------------
; API "PtInRect" determines if a specified point lies within specified rectangle
;------------------------------------------------------------------------------
push    pointy                  ;ypt, POINT structure
push    pointx                  ;xpt, Point structure
push    OFFSET right_rc_left    ;lprc, address structure with rectangle
call    PtInRect                ;- API Function -
cmp     eax,1h                  ;return value 1h=match
je      MoveWin                 ;
jmp     WP1_return_0
MoveWin:
;------------------------------------------------------------------------------
; API "ReleaseCapture" releases the mouse capture from a window.
;------------------------------------------------------------------------------
call    ReleaseCapture          ;- API Function -
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the window
;------------------------------------------------------------------------------
push    0h                      ;lParam,
push    2h                      ;wParam, HTCAPTION
push    0A1h                    ;uMsg, WM_NCLBUTTONDOWN
push    WP1_hWnd                ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
jmp     WP1_return_0

;==============================================================================
; WM_USER (value=500h) message recieved ? We define this value above in WM_SIZE
;------------------------------------------------------------------------------
WP1_uMsg_500h:
cmp     eax,500h                ;check if WM_USER message recieved
jne     WP1_return              ;if not goto label
mov     eax,WP1_wParam          ;
cmp     ax,0h                   ;our tray icon's ID
jne     WP1_return              ;
mov     eax,WP1_lParam          ;
cmp     eax,201h                ;mouse message, WM_LBUTTONDOWN=201h
jne     WP1_return              ;
;------------------------------------------------------------------------------
; API "Shell_NotifyIconA" here sends a msg. to the system to add a taskbar icon 
;------------------------------------------------------------------------------
push    OFFSET nid_cbSize       ;pnid, address of NOTIFYCONDATA struc.
push    2h                      ;dwMessage, NIM_DELETE=2h
call    Shell_NotifyIconA       ;- API Function -
;------------------------------------------------------------------------------
; API "ShowWindow" function sets the specified window's show state. 
;------------------------------------------------------------------------------
push    9h                      ;nCmdShow, show state 9=SW_RESTORE
push    WP1_hWnd                ;hwnd, handle of window
call    ShowWindow              ;- API Function -
;------------------------------------------------------------------------------
; API "SetForegroundWindow" puts the specified window into the foreground.
;------------------------------------------------------------------------------
push    WP1_hWnd                ;hwnd, handle of window
call    SetForegroundWindow     ;- API Function -
jmp     WP1_return

;==============================================================================
; API "DefWindowProcA" calls the window procedure to provide default processing
; for any window messages that an application does not process.
; This function ensures that every message is processed.
; It is called with the same parameters received by the window procedure.
;------------------------------------------------------------------------------
WP1_return:
popad                           ;pop all register from stack
push    WP1_lParam              ;extra info about the message
push    WP1_wParam              ;extra info about the message
push    WP1_uMsg                ;the message number
push    WP1_hWnd                ;handle of window who receives message
call    DefWindowProcA          ;- API Function -
mov     esp,ebp                 ;delete stack frame
pop     ebp                     ;
ret     10h                     ;return and clear stack

;==============================================================================
; Leaving the window procedure returning TRUE (1) or FALSE (0) in EAX.
;------------------------------------------------------------------------------
WP1_return_0:
popad                           ;pop all register from stack
mov     eax,0h                  ;set EAX to FALSE (0)
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack
WP1_return_1:
popad                           ;pop all register from stack
mov     eax,1h                  ;set EAX to TRUE (1)
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack
;##############################################################################



;##############################################################################
; HIGH RESOLUTION TIMER procedure (Mmedia.hlp) !
;------------------------------------------------------------------------------
TP:
push    ebp                     ;create stack frame
mov     ebp,esp
pushad                          ;push all register to the stack

cmp     flag_MCI_open,1
je      My_PositionCDAudio;TP_GoCommand0
;------------------------------------------------------------------------------
; API "MCIWndCreate" registers the MCI window class and creates an MCI window.
; It can also open an MCI device or file and associate it with the MCI window.
; For this API we push 4 doublewords to the stack, we MUST clear the stack !
;------------------------------------------------------------------------------
My_OpenCDAudio:
;------------------------------------------------------------------------------
; API "mciSendCommandA" here opens the device
;------------------------------------------------------------------------------
mov     open_lpstrDeviceType,516;fill MCI_OPEN_PARMS structure
                                ;MCI_DEVTYPE_CD_AUDIO = 516
push    OFFSET open_dwCallback  ;dwParam, address MCI_OPEN_PARMS struc.
push    3100h                   ;fdwCommand, MCI_OPEN_TYPE      = 2000h
                                ;            MCI_OPEN_TYPE_ID   = 1000h
                                ;            MCI_OPEN_SHAREABLE =  100h
push    0803h                   ;uMsg, command message, MCI_OPEN
push    0h                      ;IDDevice, not used with MCI_OPEN
call    mciSendCommandA         ;- API Function -
;------------------------------------------------------------------------------
; API "mciSendCommandA" here sets the time format and audio format
; TMSF = track, minute, second, frame
;------------------------------------------------------------------------------
mov     set_dwTimeFormat,0Ah    ;fill MCI_SET_PARMS structure
                                ;MCI_FORMAT_TMSF = 0Ah
mov     set_dwAudio,6401h       ;fill MCI_SET_PARMS structure
                                ;MCI_SET_AUDIO_ALL  = 4001h
                                ;MCI_SET_ON         = 2000h
                                ;MCI_SET_TIME_FORMAT=  400h
push    OFFSET set_dwCallback   ;dwParam, address MCI_SET_PARMS struc.
push    6401h                   ;fdwCommand, same as above 
push    080Dh                   ;uMsg, command message, MCI_SET
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN above
call    mciSendCommandA         ;- API Function -
mov     flag_MCI_open,1         ; set opening device done flag
jmp     TP_return
;---

;//////////////////////////////////////////////////////////////////////////////
My_PositionCDAudio:             ; FIX: REPLAY SAME DISK WITHOUT EJECTING AFTER END OF LAST TRACK ERROR
;//////////////////////////////////////////////////////////////////////////////
cmp     flag_MCI_open,1
jne     TP_return
;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about max. number of tracks
;------------------------------------------------------------------------------
mov     status_dwItem,03h       ;structure, MCI_STATUS_NUMBER_OF_TRACKS
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM = 0100h
push    0814h                   ;uMsg, message to send (MCI_STATUS)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     ebx,status_dwReturn     ;value from MCI_STATUS_PARMS structure

;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about the current track
;------------------------------------------------------------------------------
mov     status_dwItem,08h       ;fill struc., MCI_STATUS_CURRENT_TRACK
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM = 0100h
push    0814h                   ;uMsg, command message, MCI_STATUS
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     eax,status_dwReturn     ;value from MCI_STATUS_PARMS structure
cmp     eax,ebx                 ;check if current track is the last track
jne     TP_GoCommand0           ;if current track is not the last track

;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves the length of the specified track
;------------------------------------------------------------------------------
mov     status_dwTrack,eax      ;obtain track information
mov     status_dwItem,01h       ;structure, MCI_STATUS_LENGTH
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0110h                   ;fdwCommand, MCI_STATUS_ITEM = 0100h, MCI_TRACK=10h
push    0814h                   ;uMsg, message to send (MCI_STATUS)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     ebx,status_dwReturn     ;value from MCI_STATUS_PARMS structure
and     ebx,0FFFFh              ;minutes and seconds are in bx, mask it

;------------------------------------------------------------------------------
; API "mciSendCommandA" retrieves information about the current track position
;------------------------------------------------------------------------------
mov     status_dwItem,02h       ;fill struc., MCI_STATUS_POSITION
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM = 0100h
push    0814h                   ;uMsg, command message, MCI_STATUS
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     eax,status_dwReturn     ;value from MCI_STATUS_PARMS structure
shr     eax,8                   ;move minutes and seconds in ax, from TMSF
and     eax,0FFFFh              ;minutes and seconds are in ax, mask it

cmp     al,bl                   ;compare minutes
jb      TP_GoCommand0           ;if not the end in minutes of last track
cmp     ah,bh                   ;compare seconds
jb      TP_GoCommand0           ;if not the end in seconds of last track

;------------------------------------------------------------------------------
; API "mciSendCommandA" here stops playing the current track
;------------------------------------------------------------------------------
push    OFFSET generic_dwCallback;dwParam, MCI_GENERIC_PARMS structure
push    0h                      ;fdwCommand, 0h=no command
push    0808h                   ;uMsg, message to send (MCI_STOP)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -

;------------------------------------------------------------------------------
; API "mciSendCommandA" here releases access to a device or file.
;------------------------------------------------------------------------------
push    OFFSET generic_dwCallback;dwParam, MCI_GENERIC_PARMS structure
push    0h                      ;fdwCommand, 0h=no command
push    804h                    ;uMsg, message to send (MCI_CLOSE)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
call    My_Downlight_Play       ;- SubRoutine -
call    My_Downlight_Pause      ;- SubRoutine -
mov     flag_MCI_pause,0h       ;reset pause flag
mov     flag_MCI_play,0h        ;reset play flag
mov     flag_MCI_open,0         ;reset mci open flag because we close it above
jmp     TP_return
;//////////////////////////////////////////////////////////////////////////////



TP_GoCommand0:
cmp     flag_MCI_cmd,0h         ;
jne     TP_GoCommand1
mov     flag_MCI_cmd,0FFh       ;Reset flag
call    My_MCI_PreviousTrack    ;- SubRoutine -
jmp     TP_return
TP_GoCommand1:
cmp     flag_MCI_cmd,1h         ;
jne     TP_GoCommand2
mov     flag_MCI_cmd,0FFh       ;Reset flag
call    My_MCI_Stop             ;- SubRoutine -
jmp     TP_return
TP_GoCommand2:
cmp     flag_MCI_cmd,2h         ;
jne     TP_GoCommand3
mov     flag_MCI_cmd,0FFh       ;Reset flag
call    My_MCI_Play             ;- SubRoutine -
jmp     TP_return
TP_GoCommand3:
cmp     flag_MCI_cmd,3h         ;
jne     TP_GoCommand4
mov     flag_MCI_cmd,0FFh       ;Reset flag
call    My_MCI_Pause            ;- SubRoutine -
jmp     TP_return
TP_GoCommand4:
cmp     flag_MCI_cmd,4h         ;
jne     TP_GoCommand7
mov     flag_MCI_cmd,0FFh       ;Reset flag
call    My_MCI_NextTrack        ;- SubRoutine -
jmp     TP_return
TP_GoCommand7:
cmp     flag_MCI_cmd,7h         ;
jne     TP_GoCommand9
mov     flag_MCI_cmd,0FFh       ;Reset flag
call    My_MCI_Eject            ;- SubRoutine -
jmp     TP_return
TP_GoCommand9:
cmp     flag_MCI_cmd,9h         ;
jne     TP_GoStatus
mov     flag_MCI_cmd,0FFh       ;Reset flag
call    My_MCI_StopRelease      ;- SubRoutine -
jmp     TP_return
;---
TP_GoStatus:
cmp     flag_MCI_pause,4h       ;check pause flag
je      MediaTest0              ;
;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about the current mode
;------------------------------------------------------------------------------
mov     status_dwItem,04h       ;fill struc., MCI_STATUS_MODE
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM  = 0100h
push    0814h                   ;uMsg, message to send (MCI_STATUS)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
cmp     status_dwReturn,525     ;MCI_MODE_STOP=525
jne     MediaTest0              ;
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
push    0h                      ;lParam, set to 0
push    0h                      ;wParam, set to 0
push    0F6h                    ;uMsg, message to send ( BM_GETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,8                   ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
mov     ebx,OFFSET BUTTON_hBMP  ;get OFFSET to array of object handle
add     ebx,8                   ;add
cmp     eax,[ebx]               ;[ebx]=handle of current object
je      MediaTest0              ;
mov     ebx,OFFSET BUTTON_hBMP  ;get OFFSET to array of object handle
add     ebx,8                   ;add
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
push    [ebx]                   ;lParam, handle of bitmap
push    0h                      ;wParam, first message ( IMAGE_BITMAP )
push    0F7h                    ;uMsg, message to send ( BM_SETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,8                   ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
mov     flag_MCI_play,0h        ;clear play flag
MediaTest0:
;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about the current position
;------------------------------------------------------------------------------
mov     status_dwItem,02h       ;fill struc., MCI_STATUS_POSITION
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM  = 0100h
push    0814h                   ;uMsg, message to send (MCI_STATUS)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
cmp     eax,0h                  ;0=success
je      MediaTest1              ;
call    My_DisplayError         ;- SubRoutine -
jmp     TP_return
MediaTest1:
cmp     flag_MCI_eject,1h       ;
jne     MediaOK                 ;
;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about the current track
;------------------------------------------------------------------------------
push    OFFSET seek_dwCallback  ;dwParam, MCI_SEEK_PARMS structure
push    0100h                   ;fdwCommand, MCI_SEEK_TO_START=100h
push    0807h                   ;uMsg, command message, MCI_SEEK
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     flag_MCI_eject,0h       ;
;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about the current position
;------------------------------------------------------------------------------
mov     status_dwItem,02h       ;fill struc., MCI_STATUS_POSITION
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM  = 0100h
push    0814h                   ;uMsg, message to send (MCI_STATUS)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
MediaOK:
call    My_DisplayDigit         ;- SubRoutine -
jmp     TP_return
;---
TP_return:
popad                           ;pop all register from stack
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     14h                     ;return and clear stack (14h !)

;------------------------------------------------------------------------------
My_DisplayError:                ; Timer Procedure Subroutine
;------------------------------------------------------------------------------
mov     flag_MCI,0h             ;
mov     flag_MCI_eject,1h       ;set eject flag
mov     flag_MCI_play,0h        ;clear play flag
mov     flag_MCI_pause,0h       ;clear pause flag
mov     tempT,8h                ;var, so win do not destroy it ...
mov     counterT,0h             ;counterT
Check_Buttons:
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
push    0h                      ;lParam, set to 0
push    0h                      ;wParam, set to 0
push    0F6h                    ;uMsg, message to send ( BM_GETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,tempT               ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
mov     ebx,OFFSET BUTTON_hBMP  ;get OFFSET to array of object handle
add     ebx,tempT               ;add
cmp     eax,[ebx]               ;[ebx]=handle of current object
je      Check_Buttons_Inc
mov     ebx,OFFSET BUTTON_hBMP  ;get OFFSET to array of object handle
add     ebx,tempT               ;add
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
push    [ebx]                   ;lParam, handle of bitmap
push    0h                      ;wParam, first message ( IMAGE_BITMAP )
push    0F7h                    ;uMsg, message to send ( BM_SETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,tempT               ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
Check_Buttons_Inc:
add     tempT,4                 ;add 4 because a doubleword contains 4 byte
inc     counterT
cmp     counterT,2h             ;max. number of extra bitmaps
jb      Check_Buttons           ;loop

mov     tempT,0h                ;store it in var, so win do not destroy it ...
mov     counterT,0h             ;counterT for number of windows created
DisplayError:
mov     ebx,OFFSET STATIC_old
add     ebx,tempT
mov     eax,0Ah
cmp     [ebx],eax
je      DisplayError_next       ;skip if not a new digit
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array handle of the image
add     ebx,44
push    [ebx]                   ;push it
push    0h                      ;wParam, fImageType, IMAGE_BITMAP=0h
push    172h                    ;uMsg, STM_SETIMAGE=172h
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array handle of the window
add     ebx,tempT
push    [ebx]                   ;push it
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "CreateRectRgn" creates a rectangular region.
;------------------------------------------------------------------------------
push    21                      ;nBottomRect,y-coord lower-right corner
push    16                      ;nRightRect,x-coord lower-right corner
push    0h                      ;nTopRect,y-coord upper-left corner
push    0h                      ;nLeftRect,x-coord upper-left corner
call    CreateRectRgn           ;- API Function -
mov     hRgn,eax                ;store handle in tempT
;------------------------------------------------------------------------------
; API "GetWindowRgn" obtains a copy of the window region of a window.
;------------------------------------------------------------------------------
push    hRgn                    ;hRgn, receives a copy of the window region
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array handle of the window
add     ebx,44
push    [ebx]                   ;push it
call    GetWindowRgn            ;- API Function -
push    1h
push    hRgn
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array handle of the window
add     ebx,tempT
push    [ebx]                   ;push it
call    SetWindowRgn
;------------------------------------------------------------------------------
; API "DeleteObject" here deletes a region, the handle is no longer valid.
;------------------------------------------------------------------------------
push    hRgn                    ;hObject, handle object
call    DeleteObject            ;- API Function -
mov     ebx,OFFSET STATIC_old
add     ebx,tempT
mov     eax,0Ah
mov     [ebx],eax
DisplayError_next:
add     tempT,4                 ;add 4 because a doubleword contains 4 byte
inc     counterT                ;inc counterT
cmp     counterT,06h            ;max. number of BUTTON windows
jb      DisplayError            ;loop if below
ret

;------------------------------------------------------------------------------
My_DisplayDigit:                ; Timer Procedure Subroutine
;------------------------------------------------------------------------------
mov     flag_MCI,1h             ;
mov     tempT,0h                ;store it in var, so win do not destroy it ...
mov     counterT,0h             ;counterT for number of windows created
DisplayDigit:
mov     eax,status_dwReturn     ;value from MCI_STATUS_PARMS structure
mov     ebx,OFFSET STATIC_and
add     ebx,counterT
add     ebx,counterT
add     ebx,counterT
add     ebx,counterT
and     eax,[ebx]
mov     ebx,OFFSET STATIC_shr
add     ebx,counterT
mov     cl,[ebx]
shr     eax,cl
;------------------------------------------------------------------------------
; Calculate digits
;------------------------------------------------------------------------------
mov     ecx,eax                 ;move EAX into ECX, use ECX as a counterT
xor     esi,esi                 ;set to 0
xor     edi,edi
cmp     ecx,0h
je      UpdateHD
CountDigit_loop:
inc     esi                     ;this routine converts HEX into ASCII
cmp     esi,0Ah
jne     CountDigit_next
mov     esi,0h
inc     edi
CountDigit_next:
dec     ecx
jne     CountDigit_loop         ;jump to LABEL if counterT ECX is not 0
UpdateHD:
mov     ebx,OFFSET STATIC_old
add     ebx,tempT
cmp     [ebx],edi
je      UpdateLD                ;skip if not a new digit
mov     [ebx],edi
add     edi,edi
add     edi,edi
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array of window handle
add     ebx,tempT               ;add
mov     eax,[ebx]               ;hwnd, get handle of window
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array handle of the image
add     ebx,edi
push    [ebx]                   ;push it
push    0h                      ;wParam, fImageType, IMAGE_BITMAP=0h
push    172h                    ;uMsg, STM_SETIMAGE=172h
push    eax                     ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "CreateRectRgn" creates a rectangular region.
;------------------------------------------------------------------------------
push    21                      ;nBottomRect,y-coord lower-right corner
push    16                      ;nRightRect,x-coord lower-right corner
push    0h                      ;nTopRect,y-coord upper-left corner
push    0h                      ;nLeftRect,x-coord upper-left corner
call    CreateRectRgn           ;- API Function -
mov     hRgn,eax                ;store handle in tempT
;------------------------------------------------------------------------------
; API "GetWindowRgn" obtains a copy of the window region of a window.
;------------------------------------------------------------------------------
push    hRgn                    ;hRgn, receives a copy of the window region
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array handle of the window
add     ebx,edi
push    [ebx]                   ;push it
call    GetWindowRgn            ;- API Function -
push    1h
push    hRgn
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array handle of window handle
add     ebx,tempT
push    [ebx]                   ;push it
call    SetWindowRgn            ;- API Function -
;------------------------------------------------------------------------------
; API "DeleteObject" here deletes a region, the handle is no longer valid.
;------------------------------------------------------------------------------
push    hRgn                    ;hObject, handle object
call    DeleteObject            ;- API Function -
UpdateLD:
mov     ebx,OFFSET STATIC_old
add     ebx,tempT
add     ebx,4h
cmp     [ebx],esi
je      DisplayDigit_next       ;skip if not a new digit
mov     [ebx],esi
add     esi,esi
add     esi,esi
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array of window handle
add     ebx,tempT
add     ebx,4h                  ;add
mov     eax,[ebx]               ;hwnd, get handle of window
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array handle of the image
add     ebx,esi
push    [ebx]                   ;push it
push    0h                      ;wParam, fImageType, IMAGE_BITMAP=0h
push    172h                    ;uMsg, STM_SETIMAGE=172h
push    eax                     ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "CreateRectRgn" creates a rectangular region.
;------------------------------------------------------------------------------
push    21                      ;nBottomRect,y-coord lower-right corner
push    16                      ;nRightRect,x-coord lower-right corner
push    0h                      ;nTopRect,y-coord upper-left corner
push    0h                      ;nLeftRect,x-coord upper-left corner
call    CreateRectRgn           ;- API Function -
mov     hRgn,eax                ;store handle in tempT
;------------------------------------------------------------------------------
; API "GetWindowRgn" obtains a copy of the window region of a window.
;------------------------------------------------------------------------------
push    hRgn                    ;hRgn, receives a copy of the window region
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array handle of the window
add     ebx,esi
push    [ebx]                   ;push it
call    GetWindowRgn            ;- API Function -
push    1h
push    hRgn
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array handle of window handle
add     ebx,tempT
add     ebx,4
push    [ebx]                   ;push it
call    SetWindowRgn            ;- API Function -
;------------------------------------------------------------------------------
; API "DeleteObject" here deletes a region, the handle is no longer valid.
;------------------------------------------------------------------------------
push    hRgn                    ;hObject, handle object
call    DeleteObject            ;- API Function -
DisplayDigit_next:
add     tempT,8                 ;add 4 because a doubleword contains 4 byte
inc     counterT                ;inc counterT
cmp     counterT,03h            ;max. number of loops
jb      DisplayDigit            ;loop if below
ret

My_MCI_StopRelease:
;------------------------------------------------------------------------------
; API "mciSendCommandA" here stops playing the current track
;------------------------------------------------------------------------------
push    OFFSET generic_dwCallback;dwParam, MCI_GENERIC_PARMS structure
push    0h                      ;fdwCommand, 0h=no command
push    0808h                   ;uMsg, message to send (MCI_STOP)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
;------------------------------------------------------------------------------
; API "mciSendCommandA" here releases access to a device or file.
;------------------------------------------------------------------------------
push    OFFSET generic_dwCallback;dwParam, MCI_GENERIC_PARMS structure
push    0h                      ;fdwCommand, 0h=no command
push    804h                    ;uMsg, message to send (MCI_CLOSE)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
ret

My_MCI_PreviousTrack:
cmp     flag_MCI,0h             ;
je      My_MCI_PreviousTrack_ret;
call    My_CurrentTrack         ;- SubRoutine -
;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about max. number of tracks
;------------------------------------------------------------------------------
mov     status_dwItem,03h       ;structure, MCI_STATUS_NUMBER_OF_TRACKS
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM = 0100h
push    0814h                   ;uMsg, message to send (MCI_STATUS)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     eax,status_dwReturn     ;value from MCI_STATUS_PARMS structure
cmp     play_dwFrom,1h          ;check if current track is the first
ja      TrackDown               ;it is not the first so go to LABEL
inc     eax                     ;inc highest possible track ...
mov     play_dwFrom,eax         ;move EAX into play_dwFrom structure
TrackDown:
dec     play_dwFrom             ;dec play_dwFrom
;------------------------------------------------------------------------------
; API "mciSendCommandA" here plays from the choosen track to the end of media
;------------------------------------------------------------------------------
push    OFFSET play_dwCallback  ;dwParam, address MCI_PLAY_PARMS struc.
push    04h                     ;fdwCommand, MCI_FROM
push    0806h                   ;uMsg, message to send (MCI_PLAY)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
call    My_Highlight_Play       ;- SubRoutine -
call    My_Downlight_Pause      ;- SubRoutine -
mov     flag_MCI_play,1h        ;set play flag
mov     flag_MCI_pause,0h       ;reset pause flag
My_MCI_PreviousTrack_ret:
ret

My_MCI_Play:
cmp     flag_MCI,0h             ;
je      My_MCI_Play_ret         ;
call    My_CurrentTrack         ;- SubRoutine -
;------------------------------------------------------------------------------
; API "mciSendCommandA" here plays from the choosen track to the end of media
;------------------------------------------------------------------------------
push    OFFSET play_dwCallback  ;dwParam, address MCI_PLAY_PARMS struc.
mov     eax,04h                 ;fdwCommand, MCI_FROM
xor     eax,flag_MCI_pause      ;if pause flag is set (4h), xor 4,4=0
push    eax                     ;fdwCommand, 4h=MCI_FROM, 0h=resume
push    0806h                   ;uMsg, message to send (MCI_PLAY)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     flag_MCI_play,1h        ;set play flag
mov     flag_MCI_pause,0h       ;reset pause flag
call    My_Highlight_Play       ;- SubRoutine -
call    My_Downlight_Pause      ;- SubRoutine -
My_MCI_Play_ret:
ret

My_MCI_Pause:
cmp     flag_MCI,0h             ;
je      My_MCI_Pause_ret        ;
cmp     flag_MCI_play,0h        ;
je      My_MCI_Pause_ret        ;
;------------------------------------------------------------------------------
; API "mciSendCommandA" here pause playing the current track
;------------------------------------------------------------------------------
push    OFFSET generic_dwCallback;dwParam, MCI_GENERIC_PARMS structure
push    0h                      ;fdwCommand, 0h=no command
push    0809h                   ;uMsg, command message, MCI_PAUSE
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     flag_MCI_play,0h        ;reset play flag
mov     flag_MCI_pause,4h       ;set pause flag
call    My_Highlight_Pause      ;- SubRoutine -
call    My_Downlight_Play       ;- SubRoutine -
My_MCI_Pause_ret:
ret

My_MCI_Stop:
cmp     flag_MCI,0h             ;
je      My_MCI_Stop_ret         ;
;------------------------------------------------------------------------------
; API "mciSendCommandA" here stops playing the current track
;------------------------------------------------------------------------------
push    OFFSET generic_dwCallback;dwParam, MCI_GENERIC_PARMS structure
push    0h                      ;fdwCommand, 0h=no command
push    0808h                   ;uMsg, message to send (MCI_STOP)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
call    My_Downlight_Play       ;- SubRoutine -
call    My_Downlight_Pause      ;- SubRoutine -
mov     flag_MCI_pause,0h       ;reset pause flag
mov     flag_MCI_play,0h        ;reset play flag
My_MCI_Stop_ret:
ret

My_MCI_NextTrack:
cmp     flag_MCI,0h             ;
je      My_MCI_NextTrack_ret    ;
call    My_CurrentTrack         ;- SubRoutine -
;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about max. number of tracks
;------------------------------------------------------------------------------
mov     status_dwItem,03h       ;structure, MCI_STATUS_NUMBER_OF_TRACKS
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM = 0100h
push    0814h                   ;uMsg, message to send (MCI_STATUS)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     eax,status_dwReturn     ;value from MCI_STATUS_PARMS structure
inc     play_dwFrom             ;inc track number
cmp     play_dwFrom,eax         ;check if next track is possible
jbe     TrackUp                 ;track is avaible so play it
mov     play_dwFrom,1h          ;it is not avaible so start over
TrackUp:
;------------------------------------------------------------------------------
; API "mciSendCommandA" here plays from the choosen track to the end of media
;------------------------------------------------------------------------------
push    OFFSET play_dwCallback  ;dwParam, address MCI_PLAY_PARMS struc.
push    04h                     ;fdwCommand, MCI_FROM
push    0806h                   ;uMsg, message to send (MCI_PLAY)
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
call    My_Downlight_Pause      ;- SubRoutine -
call    My_Highlight_Play       ;- SubRoutine -
mov     flag_MCI_play,1h        ;set play flag
mov     flag_MCI_pause,0h       ;reset pause flag
My_MCI_NextTrack_ret:
ret

My_MCI_Eject:
;------------------------------------------------------------------------------
; API "mciSendCommandA" here opens the cdrom door
;------------------------------------------------------------------------------
push    OFFSET set_dwCallback   ;dwParam, address MCI_SET_PARMS struc.
push    0100h                   ;fdwCommand, MCI_SET_DOOR_OPEN
push    080Dh                   ;uMsg, command message, MCI_SET
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     flag_MCI_play,0h        ;set play flag
mov     flag_MCI_pause,0h       ;reset pause flag
ret

My_Highlight_Play:
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
mov     ebx,OFFSET EXTRA_hBMP   ;get OFFSET to array of bitmap handle
add     ebx,0                   ;add
push    [ebx]                   ;lParam, handle of bitmap
push    0h                      ;wParam, first message ( IMAGE_BITMAP )
push    0F7h                    ;uMsg, message to send ( BM_SETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,8                   ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
ret

My_Downlight_Play:
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
mov     ebx,OFFSET BUTTON_hBMP  ;get OFFSET to array of bitmap handle
add     ebx,8                   ;add
push    [ebx]                   ;lParam, handle of bitmap
push    0h                      ;wParam, first message ( IMAGE_BITMAP )
push    0F7h                    ;uMsg, message to send ( BM_SETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,8                   ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
ret

My_Highlight_Pause:
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
mov     ebx,OFFSET EXTRA_hBMP   ;get OFFSET to array of bitmap handle
add     ebx,4                   ;add
push    [ebx]                   ;lParam, handle of bitmap
push    0h                      ;wParam, first message ( IMAGE_BITMAP )
push    0F7h                    ;uMsg, message to send ( BM_SETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,12                  ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
ret

My_Downlight_Pause:
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
mov     ebx,OFFSET BUTTON_hBMP  ;get OFFSET to array of bitmap handle
add     ebx,12                  ;add
push    [ebx]                   ;lParam, handle of bitmap
push    0h                      ;wParam, first message ( IMAGE_BITMAP )
push    0F7h                    ;uMsg, message to send ( BM_SETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,12                  ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
ret

My_CurrentTrack:
;------------------------------------------------------------------------------
; API "mciSendCommandA" here retrieves information about the current track
;------------------------------------------------------------------------------
mov     status_dwItem,08h       ;fill struc., MCI_STATUS_CURRENT_TRACK
push    OFFSET status_dwCallback;dwParam, MCI_STATUS_PARMS structure
push    0100h                   ;fdwCommand, MCI_STATUS_ITEM = 0100h
push    0814h                   ;uMsg, command message, MCI_STATUS
push    open_wDeviceID          ;IDDevice, given from MCI_OPEN
call    mciSendCommandA         ;- API Function -
mov     eax,status_dwReturn     ;value from MCI_STATUS_PARMS structure
mov     play_dwFrom,eax         ;store it in structure
ret
;##############################################################################



;##############################################################################
; Init Call Table for clicking in the rectangle BUTTON windows
;------------------------------------------------------------------------------
My_Init_BUTTON_Table:
mov     ebx,OFFSET BUTTON_Table     ;get OFFSET to array of Button call table
mov     [ebx],OFFSET My_BUTTON_00   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_01   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_02   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_03   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_04   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_05   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_06   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_07   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_08   ;store pointer
add     ebx,4h                      ;next entry
mov     [ebx],OFFSET My_BUTTON_09   ;store pointer
ret
;------------------------------------------------------------------------------
My_BUTTON_00:
mov     flag_MCI_cmd,0h
;call    My_MCI_PreviousTrack    ;- SubRoutine -
ret

My_BUTTON_01:
mov     flag_MCI_cmd,1h
;call    My_MCI_Stop             ;- SubRoutine -
ret

My_BUTTON_02:
mov     flag_MCI_cmd,2h
;call    My_MCI_Play             ;- SubRoutine -
ret

My_BUTTON_03:
mov     flag_MCI_cmd,3h
;call    My_MCI_Pause            ;- SubRoutine -
ret

My_BUTTON_04:
mov     flag_MCI_cmd,4h
;call    My_MCI_NextTrack        ;- SubRoutine -
ret

My_BUTTON_05:
call    My_Internet             ;- SubRoutine -
ret

My_BUTTON_06:
call    My_Control              ;- SubRoutine -
ret

My_BUTTON_07:
mov     flag_MCI_cmd,7h
;call    My_MCI_Eject            ;- SubRoutine -
ret

My_BUTTON_08:
call    My_TrayWindow           ;- SubRoutine -
ret

My_BUTTON_09:
mov     flag_MCI_cmd,9h
push    200
call    Sleep
call    My_DestroyProgram       ;- SubRoutine -
ret
;##############################################################################


;******************************************************************************
; My own subroutine(s) for a compacter code resist here ...
;------------------------------------------------------------------------------
My_CleanSystem:
;------------------------------------------------------------------------------
; The timeKillEvent function cancels a specified high precision timer event.
;------------------------------------------------------------------------------
push    timerevent              ;uTimerID, ID of timer event to cancel
call    timeKillEvent           ;- API Function -
;------------------------------------------------------------------------------
; API "DeleteObject" deletes the BUTTON bitmap  object's assigned on WM_Create.
;------------------------------------------------------------------------------
mov     temp,0h                 ;store it in var, so win do not destroy it ...
mov     counter,0               ;counter for number of windows created
DeleteButtonBitmap:
mov     ebx,OFFSET BUTTON_hBMP  ;get OFFSET to array of object handle
add     ebx,temp                ;add
push    [ebx]                   ;hObject, handle object
call    DeleteObject            ;- API Function -
add     temp,4                  ;add 4 because a doubleword contains 4 byte
inc     counter                 ;inc counter
cmp     counter,0Ah             ;max number of button windows ...
jb      DeleteButtonBitmap      ;loop if below
;------------------------------------------------------------------------------
; API "DeleteObject" deletes the STATIC bitmap object's assigned on WM_Create.
;------------------------------------------------------------------------------
mov     temp,0h                 ;store it in var, so win do not destroy it ...
mov     counter,0               ;counter for number of windows created
DeleteStaticBitmap:
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array of object handle
add     ebx,temp                ;add
push    [ebx]                   ;hObject, handle object
call    DeleteObject            ;- API Function -
add     temp,4                  ;add 4 because a doubleword contains 4 byte
inc     counter                 ;inc counter
cmp     counter,0Bh             ;max number of button windows ...
jbe     DeleteStaticBitmap      ;loop if below
;------------------------------------------------------------------------------
; API "DeleteObject" deletes the STATIC bitmap object's assigned on WM_Create.
;------------------------------------------------------------------------------
mov     temp,0h                 ;store it in var, so win do not destroy it ...
mov     counter,0               ;counter
DeleteExtraBitmap:
mov     ebx,OFFSET EXTRA_hBMP   ;get OFFSET to array of object handle
add     ebx,temp                ;add
push    [ebx]                   ;hObject, handle object
call    DeleteObject            ;- API Function -
add     temp,4                  ;add 4 because a doubleword contains 4 byte
inc     counter                 ;inc counter
cmp     counter,02h             ;limit
jb      DeleteExtraBitmap       ;loop if below
;------------------------------------------------------------------------------
; API "DeleteObject" deletes a logical pen, brush, font, bitmap, region, or
; palette, freeing all system resources associated with the object.
; After the object is deleted, the specified handle is no longer valid.
;------------------------------------------------------------------------------
push    hBMP_main               ;hObject, handle object
call    DeleteObject            ;- API Function -
push    hBR_main                ;hObject, handle object
call    DeleteObject            ;- API Function -
push    hRgn                    ;hObject, handle object
call    DeleteObject            ;- API Function -
;------------------------------------------------------------------------------
; API "DeleteDC" deletes the specified device context (DC).
;------------------------------------------------------------------------------
push    hDC_main                ;hdc, handle of device context
call    DeleteDC                ;- API Function -
ret

My_Rgn_main:
;------------------------------------------------------------------------------
; API "GetDC" retrieves a handle of a display device context (DC) for the
; client area of the specified window.
;------------------------------------------------------------------------------
push    WP1_hWnd                ;hwnd, handle of window
call    GetDC                   ;- API Function -
mov     ebx,eax                 ;handle of device context
;------------------------------------------------------------------------------
; API "CreateCompatibleDC" creates a memory device context (DC) compatible
; with the specified device.
;------------------------------------------------------------------------------
push    ebx                     ;hdc, display device (DC)=dest.
call    CreateCompatibleDC      ;- API Function -
mov     hDC_main,eax            ;handle, memory device (DC)=src.
;------------------------------------------------------------------------------
; API "ReleaseDC" releases a device context (DC), freeing it for use by other.
;------------------------------------------------------------------------------
push    ebx                     ;hdc, handle of device context
push    WP1_hWnd                ;hwnd, handle of window
call    ReleaseDC               ;- API Function -
;------------------------------------------------------------------------------
; API "SelectObject" selects an object into the specified device context
;------------------------------------------------------------------------------
push    hBMP_main               ;hObject, handle of bitmap
push    hDC_main                ;hdc, id memory device (DC)=src.
call    SelectObject            ;- API Function -
mov     hObj_old,eax            ;handle of old object
;------------------------------------------------------------------------------
; API "GetPixel" retrieves the red, green, blue (RGB) color value of the pixel
;------------------------------------------------------------------------------
push    0h                      ;nYPos, y-coordinate of pixel
push    0h                      ;nXPos, x-coordinate of pixel
push    hDC_main                ;hdc, handle of device context
call    GetPixel                ;- API Function -
mov     ebx,eax                 ;calculate main window region starts here !
mov     edi,0h
mov     esi,0FFFFFFFFh
My_Rgn_main_a1:
inc     esi
cmp     esi,Xpos_max
jbe     My_Rgn_main_a2
xor     esi,esi
inc     edi
cmp     edi,Ypos_max
ja      My_Rgn_main_return
My_Rgn_main_a2:
push    edi
push    esi
push    hDC_main
call    GetPixel
cmp     eax,ebx
je      My_Rgn_main_a1
inc     edi
push    edi
inc     esi
push    esi
dec     edi
push    edi
dec     esi
push    esi
call    CreateRectRgn
mov     hRgn,eax
My_Rgn_main_b1:
inc     esi
cmp     esi,Xpos_max
jbe     My_Rgn_main_b2
xor     esi,esi
inc     edi
cmp     edi,Ypos_max
ja      My_Rgn_main_set
My_Rgn_main_b2:
push    edi
push    esi
push    hDC_main
call    GetPixel
cmp     eax,ebx
je      My_Rgn_main_b1
push    esi
push    edi
My_Rgn_main_b3:
inc     esi
cmp     esi,Xpos_max
ja      My_Rgn_main_b4
push    edi
push    esi
push    hDC_main
call    GetPixel
cmp     eax,ebx
jne     My_Rgn_main_b3
My_Rgn_main_b4:
pop     eax
pop     ecx
inc     edi
push    edi
push    esi
push    eax
push    ecx
call    CreateRectRgn
push    eax
dec     edi
push    2h
push    eax
push    hRgn
push    hRgn
call    CombineRgn
call    DeleteObject
jmp     My_Rgn_main_b1
My_Rgn_main_set:
push    1h
push    hRgn
push    WP1_hWnd
call    SetWindowRgn
My_Rgn_main_return:
ret

My_Create_Tooltip:
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window, predefined class name (Tooltips_class32)
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
push    0h                      ;hMenu, the child-window ID
push    0h                      ;hWndParent, handle parent window 0=no
push    80000000h               ;intnHeight, CW_USEDEFAULT
push    80000000h               ;intnWidth, CW_USEDEFAULT
push    80000000h               ;inty, CW_USEDEFAULT
push    80000000h               ;intx, CW_USEDEFAULT
push    1h                      ;dwStyle, TTS_ALWAYSTIP=1h
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET ToolTipsClassName;lpClassName, pointer to class name
push    0h                      ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA         ;- API Function -
mov     hWnd_tooltip,eax        ;hwnd, return value=handle of window
ret

My_Create_Button:
mov     temp,0h                 ;store it in var, so win do not destroy it ...
mov     counter,0h              ;counter for number of windows created
CreateButton:
;------------------------------------------------------------------------------
; API "CreateWindowExA", a child window with a predefined class name (BUTTON)
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
mov     ebx,OFFSET BUTTON_id    ;get OFFSET to array window ID's
add     ebx,temp
push    [ebx]                   ;hMenu, the child-window ID
push    WP1_hWnd                ;hWndParent, handle parent window 0=no
mov     ebx,OFFSET BUTTON_height;get OFFSET to array button height
add     ebx,temp
push    [ebx]                   ;push it
mov     ebx,OFFSET BUTTON_width ;get OFFSET to array button width
add     ebx,temp
push    [ebx]                   ;push it
mov     ebx,OFFSET BUTTON_ypos  ;get OFFSET to array window ypos
add     ebx,temp
push    [ebx]                   ;inty, vertical position window
mov     ebx,OFFSET BUTTON_xpos  ;get OFFSET to array window xpos
add     ebx,temp
push    [ebx]                   ;intx, horizontal position window
push    54000080h               ;dwStyle,WS_CHILD,WS_VISIBLE,WS_CLIBSIBLINGS,BS_BITMAP
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET ButtonClassName  ;lpClassName, pointer to class name
push    0h                      ;dwExStyle,
call    CreateWindowExA         ;- API Function -
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,temp                ;add
mov     [ebx],eax               ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "LoadBitmapA" loads a bitmap from the resource file
;------------------------------------------------------------------------------
mov     ebx,OFFSET BUTTON_BMP   ;get OFFSET to array of bitmap resource id
add     ebx,temp                ;add
push    [ebx]                   ;push resource id
push    hInstance               ;hInstance, handle of modul instance
call    LoadBitmapA             ;- API Function -
mov     ebx,OFFSET BUTTON_hBMP  ;get OFFSET to array of object handle
add     ebx,temp                ;add
mov     [ebx],eax               ;hobj, store handle of object
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window Procedure lpfnWndProc
;------------------------------------------------------------------------------
push    eax                     ;lParam, handle of bitmap
push    0h                      ;wParam, first message ( IMAGE_BITMAP )
push    0F7h                    ;uMsg, message to send ( BM_SETIMAGE )
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,temp                ;add
push    [ebx]                   ;hwnd, handle of window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; Fill ToolTipInfo structure,rectangle Button windows and send TTM_ADDTOOL msg.
;------------------------------------------------------------------------------
mov     ti_cbSize,28h           ;cbSize, size of tooltipinfo structure
mov     ti_uFlags,11h           ;uFlags, TTF_SUBCLASS=10h, TTF_IDISHWND=1h
mov     eax,WP1_hWnd
mov     ti_hwnd,eax             ;hwnd, window handle
mov     ti_RECT_left,0h         ;x-coord. upper-left corner, here ignored
mov     ti_RECT_top,0h          ;y-coord. upper-left corner, here ignored
mov     ti_RECT_right,0h        ;x-coord. lower-right corner, here ignored
mov     ti_RECT_bottom,0h       ;y-coord. lower-right corner, here ignored
mov     eax,hInstance           ;
mov     ti_hinst,eax            ;hinst, modul instance
mov     ebx,OFFSET BUTTON_hWnd  ;get OFFSET to array of window handle
add     ebx,temp                ;add
mov     eax,[ebx]
mov     ti_uId,eax              ;uId, here window handle because uFlags
mov     ebx,OFFSET BUTTON_ttip  ;get OFFSET to array of window tips
add     ebx,temp                ;add
mov     eax,[ebx]
mov     ti_lpszText,eax         ;here resource ID !
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the Window
;------------------------------------------------------------------------------
push    OFFSET ti_cbSize        ;lParam, lpti, pointer TOOLINFO structure
push    0h                      ;wParam, not used, must be zero
push    1028                    ;uMsg, TTM_ADDTOOL=1028 (WM_USER + 4)
push    hWnd_tooltip            ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
add     temp,4                  ;add 4 because a doubleword contains 4 byte
inc     counter                 ;inc counter
cmp     counter,0Ah             ;max. number of BUTTON windows
jb      CreateButton            ;loop if below
ret

My_Create_Statmp:
mov     temp,0h
mov     counter,0h
CreateStatmp:
;------------------------------------------------------------------------------
; API "LoadBitmapA" loads a bitmap from the resource file
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_BMP   ;get OFFSET to array of bitmap resource id
add     ebx,temp                ;add
push    [ebx]                   ;push resource id
push    hInstance               ;hInstance, handle of modul instance
call    LoadBitmapA             ;- API Function -
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array of object handle
add     ebx,temp                ;add
mov     [ebx],eax               ;hobj, store handle of object
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (STATIC).
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
mov     ebx,OFFSET STATmp_id    ;get OFFSET to array window ID's
add     ebx,temp                ;
push    [ebx]                   ;hMenu, the child-window ID
push    WP1_hWnd                ;hWndParent, handle parent window 0=no
push    0h                      ;intnHeight, window height pixel
push    0h                      ;intnWidth, window width pixel
push    0h                      ;inty, vertical position window
push    0h                      ;intx, horizontal position window
push    4400000Eh               ;dwStyle, SS_BITMAP=0Eh
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET StaticClassName  ;lpClassName, pointer to class name
push    0h                      ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA         ;- API Function -
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array of window handle
add     ebx,temp                ;add
mov     [ebx],eax               ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array handle of the image
add     ebx,temp
push    [ebx]                   ;push it
push    0h                      ;wParam, fImageType, IMAGE_BITMAP=0h
push    172h                    ;uMsg, STM_SETIMAGE=172h
push    eax                     ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "GetDC" retrieves a handle of a display device context (DC) for the
; client area of the specified window.
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array handle of window handle
add     ebx,temp
push    [ebx]                   ;push it
call    GetDC                   ;- API Function -
mov     ebx,eax                 ;handle of device context
;------------------------------------------------------------------------------
; API "CreateCompatibleDC" creates a memory device context (DC) compatible
; with the specified device.
;------------------------------------------------------------------------------
push    ebx                     ;hdc, display device (DC)=dest.
call    CreateCompatibleDC      ;- API Function -
mov     hDC_temp,eax            ;handle, memory device (DC)=src.
;------------------------------------------------------------------------------
; API "ReleaseDC" releases a device context (DC), freeing it for use by other.
;------------------------------------------------------------------------------
push    ebx                     ;hdc, handle of device context
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array handle of window handle
add     ebx,temp
push    [ebx]                   ;push it
call    ReleaseDC               ;- API Function -
;------------------------------------------------------------------------------
; API "SelectObject" selects an object into the specified device context
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array handle of the image
add     ebx,temp
push    [ebx]                   ;push it
push    hDC_temp                ;hdc, id memory device (DC)=src.
call    SelectObject            ;- API Function -
mov     hObj_old,eax            ;handle of old object
;------------------------------------------------------------------------------
; API "GetPixel" retrieves the red, green, blue (RGB) color value of the pixel
;------------------------------------------------------------------------------
push    0h                      ;nYPos, y-coordinate of pixel
push    0h                      ;nXPos, x-coordinate of pixel
push    hDC_temp                ;hdc, handle of device context
call    GetPixel                ;- API Function -
mov     ebx,eax                 ;calculate main window region starts here !
mov     edi,0h
mov     esi,0FFFFFFFFh
My_Rgn_temp_a1:
inc     esi
cmp     esi,Xpos_Dmax
jbe     My_Rgn_temp_a2
xor     esi,esi
inc     edi
cmp     edi,Ypos_Dmax
ja      My_Rgn_temp_releaseDC
My_Rgn_temp_a2:
push    edi
push    esi
push    hDC_temp
call    GetPixel
cmp     eax,ebx
je      My_Rgn_temp_a1
inc     edi
push    edi
inc     esi
push    esi
dec     edi
push    edi
dec     esi
push    esi
call    CreateRectRgn
mov     hRgn,eax
My_Rgn_temp_b1:
inc     esi
cmp     esi,Xpos_Dmax
jbe     My_Rgn_temp_b2
xor     esi,esi
inc     edi
cmp     edi,Ypos_Dmax
ja      My_Rgn_temp_set
My_Rgn_temp_b2:
push    edi
push    esi
push    hDC_temp
call    GetPixel
cmp     eax,ebx
je      My_Rgn_temp_b1
push    esi
push    edi
My_Rgn_temp_b3:
inc     esi
cmp     esi,Xpos_Dmax
ja      My_Rgn_temp_b4
push    edi
push    esi
push    hDC_temp
call    GetPixel
cmp     eax,ebx
jne     My_Rgn_temp_b3
My_Rgn_temp_b4:
pop     eax
pop     ecx
inc     edi
push    edi
push    esi
push    eax
push    ecx
call    CreateRectRgn
push    eax
dec     edi
push    2h
push    eax
push    hRgn
push    hRgn
call    CombineRgn
call    DeleteObject
jmp     My_Rgn_temp_b1
My_Rgn_temp_set:
push    1h
push    hRgn
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array handle of window handle
add     ebx,temp
push    [ebx]                   ;push it
call    SetWindowRgn
My_Rgn_temp_releaseDC:
push    hObj_old
push    hDC_temp
call    SelectObject
push    hDC_temp
call    DeleteDC
add     temp,4                  ;add 4 because a doubleword contains 4 byte
inc     counter
cmp     counter,0Bh             ;max number of windows icons ...
jbe     CreateStatmp
ret

My_Create_Static:
mov     temp,0h
mov     counter,0h
CreateStatic:
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (STATIC).
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
mov     ebx,OFFSET STATIC_id    ;get OFFSET to array window ID's
add     ebx,temp
push    [ebx]                   ;hMenu, the child-window ID
push    WP1_hWnd                ;hWndParent, handle parent window 0=no
push    0h                      ;intnHeight, window height pixel
push    0h                      ;intnWidth, window width pixel
mov     ebx,OFFSET STATIC_ypos  ;get OFFSET to array window ypos
add     ebx,temp
push    [ebx]                   ;inty, vertical position window
mov     ebx,OFFSET STATIC_xpos  ;get OFFSET to array window xpos
add     ebx,temp
push    [ebx]                   ;intx, horizontal position window
push    5400000Eh               ;dwStyle, SS_BITMAP=0Eh
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET StaticClassName  ;lpClassName, pointer to class name
push    0h                      ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA         ;- API Function -
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array of window handle
add     ebx,temp                ;add
mov     [ebx],eax               ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array handle of the image
add     ebx,0h                  ;
push    [ebx]                   ;push it
push    0h                      ;wParam, fImageType, IMAGE_BITMAP=0h
push    172h                    ;uMsg, STM_SETIMAGE=172h
push    eax                     ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; Here we create and combine our regions, here you mask the main window !
;------------------------------------------------------------------------------
push    21                      ;nBottomRect,y-coord lower-right corner
push    16                      ;nRightRect,x-coord lower-right corner
push    0h                      ;nTopRect,y-coord upper-left corner
push    0h                      ;nLeftRect,x-coord upper-left corner
call    CreateRectRgn           ;- API Function -
mov     hRgn,eax                ;store handle in temp
;------------------------------------------------------------------------------
; API "GetWindowRgn" obtains a copy of the window region of a window.
;------------------------------------------------------------------------------
push    hRgn                    ;hRgn, receives a copy of the window region
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array handle of the window
add     ebx,0h                  ;
push    [ebx]                   ;push it
call    GetWindowRgn            ;- API Function -
push    1h
push    hRgn
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array handle of window handle
add     ebx,temp
push    [ebx]                   ;push it
call    SetWindowRgn
;------------------------------------------------------------------------------
; API "DeleteObject" here deletes a region, the handle is no longer valid.
;------------------------------------------------------------------------------
push    hRgn                    ;hObject, handle object
call    DeleteObject            ;- API Function -
add     temp,4                  ;add 4 because a doubleword contains 4 byte
inc     counter
cmp     counter,6h              ;max number of windows icons ...
jb      CreateStatic            ;loop
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (STATIC).
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
mov     ebx,OFFSET STATIC_id    ;get OFFSET to array window ID's
add     ebx,24
push    [ebx]                   ;hMenu, the child-window ID
push    WP1_hWnd                ;hWndParent, handle parent window 0=no
push    0h                      ;intnHeight, window height pixel
push    0h                      ;intnWidth, window width pixel
mov     ebx,OFFSET STATIC_ypos  ;get OFFSET to array window ypos
add     ebx,24
push    [ebx]                   ;inty, vertical position window
mov     ebx,OFFSET STATIC_xpos  ;get OFFSET to array window xpos
add     ebx,24
push    [ebx]                   ;intx, horizontal position window
push    5400000Eh               ;dwStyle, SS_BITMAP=0Eh
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET StaticClassName  ;lpClassName, pointer to class name
push    0h                      ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA         ;- API Function -
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array of window handle
add     ebx,24                  ;add
mov     [ebx],eax               ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
mov     ebx,OFFSET STATmp_hBMP  ;get OFFSET to array handle of the image
add     ebx,40                  ;
push    [ebx]                   ;push it
push    0h                      ;wParam, fImageType, IMAGE_BITMAP=0h
push    172h                    ;uMsg, STM_SETIMAGE=172h
push    eax                     ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "CreateRectRgn" creates a rectangular region.
;------------------------------------------------------------------------------
push    21                      ;nBottomRect,y-coord lower-right corner
push    16                      ;nRightRect,x-coord lower-right corner
push    0h                      ;nTopRect,y-coord upper-left corner
push    0h                      ;nLeftRect,x-coord upper-left corner
call    CreateRectRgn           ;- API Function -
mov     hRgn,eax                ;store handle in temp
;------------------------------------------------------------------------------
; API "GetWindowRgn" obtains a copy of the window region of a window.
;------------------------------------------------------------------------------
push    hRgn                    ;hRgn, receives a copy of the window region
mov     ebx,OFFSET STATmp_hWnd  ;get OFFSET to array handle of the image
add     ebx,40
push    [ebx]                   ;push it
call    GetWindowRgn            ;- API Function -
push    1h
push    hRgn
mov     ebx,OFFSET STATIC_hWnd  ;get OFFSET to array handle of window handle
add     ebx,24
push    [ebx]                   ;push it
call    SetWindowRgn
;------------------------------------------------------------------------------
; API "DeleteObject" here deletes a region, the handle is no longer valid.
;------------------------------------------------------------------------------
push    hRgn                    ;hObject, handle object
call    DeleteObject            ;- API Function -
ret

My_ExtraBitmap:
mov     temp,0h
mov     counter,0h
ExtraBitmap:
;------------------------------------------------------------------------------
; API "LoadBitmapA" loads a bitmap from the resource file
;------------------------------------------------------------------------------
mov     ebx,OFFSET EXTRA_BMP    ;get OFFSET to array of bitmap resource id
add     ebx,temp                ;add
push    [ebx]                   ;push resource id
push    hInstance               ;hInstance, handle of modul instance
call    LoadBitmapA             ;- API Function -
mov     ebx,OFFSET EXTRA_hBMP   ;get OFFSET to array of object handle
add     ebx,temp                ;add
mov     [ebx],eax               ;hobj, store handle of object
add     temp,4                  ;add 4 because a doubleword contains 4 byte
inc     counter
cmp     counter,2h              ;max. number of extra bitmaps
jb      ExtraBitmap             ;loop
ret

My_DestroyProgram:
;------------------------------------------------------------------------------
; API "DestroyWindow" function destroys the given window
;------------------------------------------------------------------------------
push    WP1_hWnd                ;hwnd, handle of window to destroy
call    DestroyWindow           ;- API Function -
ret

My_TrayWindow:
;------------------------------------------------------------------------------
; API "ShowWindow" function sets the specified window's show state. 
;------------------------------------------------------------------------------
push    6h                      ;nCmdShow, show state 6=SW_MINIMIZE
push    WP1_hWnd                ;hwnd, handle of window
call    ShowWindow              ;- API Function -
ret


My_Internet:
;------------------------------------------------------------------------------
; API "ShellExecute" opens or prints a specified file, executable or a document
;------------------------------------------------------------------------------
push    0h                      ;nShowCmd, whether file is shown when opened
push    0h                      ;lpDirectory, pointer string default directory
push    0h                      ;lpParameters, pointer to exe-file parameters
push    OFFSET TD_URL           ;lpFile, pointer to filename string
push    0h                      ;lpOperation, specifies operation to perform
push    0h                      ;hwnd, handle to parent window
call    ShellExecuteA           ;- API Function -
ret

My_Control:
;------------------------------------------------------------------------------
; API "GetSystemDirectory" retrieves the path of the Windows system directory.
;------------------------------------------------------------------------------
push    104h                    ;uSize, size of directory buffer
push    OFFSET Buffer           ;lpBuffer, address of buffer for system directory
call    GetSystemDirectoryA     ;- API Function -
;------------------------------------------------------------------------------
; API "ShellExecute" opens or prints a specified file, executable or a document
;------------------------------------------------------------------------------
push    1h                  ;nShowCmd, whether file is shown, SW_SHOWNORMAL
push    OFFSET Buffer       ;lpDirectory, pointer string default directory
push    OFFSET mmsys        ;lpParameters, pointer to exe-file parameters
push    OFFSET Control      ;lpFile, pointer to filename string
push    OFFSET OpenFile     ;lpOperation, specifies operation to perform
push    WP1_hWnd            ;hwnd, handle to parent window
call    ShellExecuteA       ;- API Function -
ret
;******************************************************************************

;==============================================================================
; end Main = end of our program code
;------------------------------------------------------------------------------
end Main                                ;end of our program code, entry point

;==============================================================================
; To create the exe file use this commands with your Microsoft Assembler/Linker
;------------------------------------------------------------------------------
; ml.exe /c /coff td_win32asm_nanocd.asm                        ;asm command
; rc.exe /v rsrc.rc                                             ;rc command
; cvtres.exe /machine:ix86 rsrc.res
; link.exe /subsystem:windows td_win32asm_nanocd.obj rsrc.obj   ;link command
;==============================================================================